<template>
  <q-page padding>
    <div class="settings-toggle q-mb-sm">
      <q-btn icon="settings" round flat @click="showSettings = !showSettings" :color="showSettings ? 'primary' : ''" />
      <q-toggle v-model="showSettings" />
    </div>

    <q-card v-if="showSettings" class="q-mb-lg">
      <q-item>
        <q-item-section>
          <q-item-label>
            <strong>First</strong>: {{ config.op1Range.min }} - {{ config.op1Range.max }}
          </q-item-label>
          <q-range v-model.number="config.op1Range" :min="1" :max="12" snap label />
        </q-item-section>
      </q-item>

      <q-item>
        <q-item-section>
          <q-item-label>
            <strong>Second</strong>: {{ config.op2Range.min }} - {{ config.op2Range.max }}
          </q-item-label>
          <q-range v-model.number="config.op2Range" :min="1" :max="12" snap label />
        </q-item-section>
      </q-item>

      <q-item>
        <q-item-section>
          <q-item-label class="text-bold">
            <q-toggle v-model="config.multiplication" label="Multiplication" />
          </q-item-label>
        </q-item-section>
      </q-item>

      <q-item>
        <q-item-section>
          <q-item-label class="text-bold">
            <q-toggle v-model="config.division" label="Division" />
          </q-item-label>
        </q-item-section>
      </q-item>

      <q-item>
        <q-item-section>
          <q-item-label class="text-bold">
            <q-toggle v-model="config.timed" label="Timed Questions" />
          </q-item-label>
          <q-item-label v-if="config.timed">
            <q-slider v-model.number="config.questionTime" :min="500" :max="7000" :step="250" snap label
                      :label-value="`${config.questionTime / 1000} seconds`"
            />
          </q-item-label>
        </q-item-section>
      </q-item>

      <q-item>
        <q-btn icon="close" @click="resetStats">Reset Score</q-btn>
      </q-item>
    </q-card>

    <div class="score-bar flex justify-center items-center q-mb-md q-gutter-md">
      <q-img v-if="streak >= hotStreak" class="on-fire" src="~assets/img/pixel-fire.gif" contain />
      <span>
        <strong>Score</strong>: {{ totalCorrect }} / {{ totalQuestions }}
      </span>
      <span>
        <strong>Streak</strong>: {{ streak }}
        <span class="text-caption text-weight-light">
           (Best: {{ longestStreak }})
        </span>
      </span>
      <q-img v-if="streak >= hotStreak" class="on-fire" src="~assets/img/pixel-fire.gif" contain />
    </div>

    <div class="flex justify-center items-center text-h4 q-mb-md">
      <q-card class="gt-xs">
        <q-linear-progress v-if="config.timed" size="sm" :value="timerProgress" />
        <q-card-section horizontal>
          <q-card-section>
            {{ problem.operand1 }}
            {{ problem.multiply ? '×' : '÷' }}
            {{ problem.operand2 }}
          </q-card-section>
        </q-card-section>
      </q-card>

      <q-linear-progress class="lt-sm" v-if="config.timed" size="sm" :value="timerProgress" />
      <div class="lt-sm">
        {{ problem.operand1 }}
        {{ problem.multiply ? '×' : '÷' }}
        {{ problem.operand2 }}
      </div>

      <div class="q-mx-md">=</div>

      <q-input ref="answer" v-model.number="answer" type="number" class="answer-box" @keydown.enter="checkAnswer"
               :disable="showCorrect"
      />
      <q-btn class="q-ml-md" icon="arrow_forward" round @click="checkAnswer" :disable="showCorrect" />
    </div>

    <div v-if="showCorrect" class="flex justify-center items-center text-h5">
      <div v-if="answer === problem.answer">
        <q-icon name="check" color="positive" />
        Right!
      </div>
      <div v-else>
        <q-icon name="close" color="negative" />
        It's {{ problem.answer }}.
      </div>
    </div>
  </q-page>
</template>

<script>
export default {
  name: 'multiplication',
  data() {
    return {
      showSettings: false,
      config: {
        op1Range: { min: 1, max: 12 },
        op2Range: { min: 1, max: 12 },
        multiplication: true,
        division: false,
        timed: false,
        questionTime: 5000,
      },
      problem: {
        multiply: true,
        operand1: 0,
        operand2: 0,
        answer: 0,
      },
      answer: null,
      showCorrect: false,
      questionStarted: 0,
      timerProgress: 1,
      hotStreak: 15,
      streak: 0,
      longestStreak: 0,
      totalQuestions: 0,
      totalCorrect: 0,
    }
  },
  mounted() {
    if (this.$q.localStorage.has('multiply-config')) {
      this.config = this.$q.localStorage.getItem('multiply-config')
    }
    this.newProblem()
    this.runTimer()
  },
  watch: {
    config: {
      deep: true,
      handler() {
        if (!this.config.multiplication && !this.config.division) {
          this.config.multiplication = true
        }
        this.$q.localStorage.set('multiply-config', this.config)
      },
    },
  },
  methods: {
    async newProblem() {
      let multiply = true
      if (!this.config.multiplication || (this.config.division && Math.random() < 0.5)) {
        multiply = false
      }

      let operand1 = Math.floor(Math.random() * (this.config.op1Range.max - this.config.op1Range.min + 1))
        + this.config.op1Range.min
      let operand2 = Math.floor(Math.random() * (this.config.op2Range.max - this.config.op2Range.min + 1))
        + this.config.op2Range.min
      let answer = operand1 * operand2

      if (multiply && Math.random() < 0.5) {
        const tmp = operand1
        operand1 = operand2
        operand2 = tmp
      }

      if (!multiply) {
        const dividend = answer
        let divisor = operand1
        if (Math.random() < 0.5) {
          answer = operand2
        }
        else {
          divisor = operand2
          answer = operand1
        }
        operand1 = dividend
        operand2 = divisor
      }

      this.problem = {
        multiply,
        operand1,
        operand2,
        answer,
      }
      this.answer = null
      this.questionStarted = Date.now()
      this.timerProgress = 1
      this.runTimer()

      this.showCorrect = false
      await this.$nextTick()
      this.$refs.answer.focus()
    },

    checkAnswer() {
      this.showCorrect = true
      this.timerProgress = 1
      this.totalQuestions += 1
      if (this.answer === this.problem.answer) {
        this.totalCorrect += 1
        this.streak += 1

        if (this.streak > this.longestStreak) {
          this.longestStreak = this.streak
        }
      }
      else {
        this.streak = 0
      }
      setTimeout(() => {
        this.newProblem()
      }, 750)
    },

    runTimer() {
      if (this.config.timed) {
        requestAnimationFrame(() => {
          this.updateTimer()
        })
      }
    },

    updateTimer() {
      if (!this.config.timed || this.showCorrect) {
        return
      }

      const elapsed = Date.now() - this.questionStarted
      if (!elapsed) {
        this.timerProgress = 1
      }
      else {
        this.timerProgress = 1 - (elapsed / this.config.questionTime)
      }

      if (this.timerProgress <= 0) {
        this.checkAnswer()
      }
      else {
        this.runTimer()
      }
    },

    resetStats() {
      this.totalCorrect = 0
      this.totalQuestions = 0
      this.streak = 0
    },
  },
}
</script>

<style scoped lang="scss">
.q-slider {
  min-width: 8rem;
}

.answer-box {
  font-size: 2rem;
  width: 6rem;
}

.on-fire {
  width: 1.5rem;
  height: 1.5rem;
}
</style>
